# Isidore

A script helping to statically generate websites using a combination of PHP,
HTML, and Markdown.

## Dependencies

- Bash
- PHP

## Usage

Synopsis: `isidore <command> [options]`

Commands:

- `new [args] <dir>`: create a new project.
  - `<dir>`: new project directory.
  - `-i`: interactive mode.
- `build [args]`: build the website.
  - `-j<n>`: number of jobs to run concurrently. With `0` it compiles all files
    at once.
  - `-v`: run with verbose output.
- `serve`, `server [args]`: run an HTTP server of the output (default port 8080).
  - `-p <port>`: port number to bind server to.
- `clean`: cleans build files.
- `help`: show help information.
- `version`: show Isidore version number.

### New Project

When you create a new project with Isidore it will create the following
directory structure:

- `<dir>/`: the project directory.
  - `site/`: contains the pages to be compiled.
  - `templates/`: templates that can be used in `site/` and can also be compiled.
  - `output/`: output directory of compiled HTML files.
  - `config.php`: configuration file with Isidore configuration and global
    variables.

## Contributing

Currently the project is still under heavy development. The idea isn't to create
some massive static site generator project, as projects like this already exist
(e.g. Hugo). The point is to create a simple program with very little
functionality, that a user can then manually edit to add extra functionality.
Though I may consider adding a directory in the project containing patch files
if anyone ever wants to send one in.

In any case, if you want to contribute towards the development of the project,
please take a look at what needs to be done in the [roadmap](/ROADMAP.md), or
check if there are any to-do comments in the code:

```bash
grep "TODO" isidore.sh
```

## License & Copyright

This project is licensed under the terms & conditions of the GNU Affero General
Public License version 3 (see the [license file](/LICENSE)) for more
information.
